;===================================================================
; Q 32768 Hz         TXATVCTS.ASM            V0.1    24 marzo 2001
;
;Trasmettitore ATV CTS
;
;-------------------------------------------------------------------
          TITLE   "Gestione TX ATV CTS"
          LIST    c=132, n=0, p=16F84, r=hex, t=off, x=on, f=inhx8m
;--------------------------------------------------------------------

          INCLUDE include/P16F84.INC

          __FUSES  _CP_OFF & _WDT_ON & _RC_OSC & _PWRTE_ON

;------- VARIABILI: reg_RAM -------------------------------------------

TEMP_1    EQU       H'0C'               ;riservato interrupt
TEMP_2    EQU       H'0D'               ;riservato interrupt
TEMP      EQU       H'0E'               ;
FLAG      EQU       H'0F'               ;riservato
;         EQU       H'10'               ; 
CONT1     EQU       H'11'               ;
CONT2     EQU       H'12'               ;
;         EQU       H'13'               ;
;         EQU       H'14'               ;
R1        EQU       H'15'               ;digit bcd 2 - 3
R0        EQU       H'16'               ;digit bcd 0 - 1 MSD
TAST_L    EQU       H'17'               ;MHZ L
TAST_M    EQU       H'18'               ;MHZ M
;         EQU       H'19'               ;
;         EQU       H'1A'               ;
;         EQU       H'1B'               ;                  
RPTL      EQU       H'1C'               ;                  
RPTM      EQU       H'1D'               ;
;         EQU       H'1E'               ;
;         EQU       H'1F'               ;temp print
TX_BUF    EQU       H'20'               ;temp send
RX_BUF    EQU       H'21'               ;rx
CONT      EQU       H'22'               ;
TDEL      EQU       H'23'               ;
RRIT      EQU       H'24'               ;
;         EQU       H'25'               ;
;         EQU       H'26'               ;
DIV_H     EQU       H'27'               ;msb divisore pll
DIV_L     EQU       H'28'               ;lsb divisore pll
;         EQU       H'29'               ;
;         EQU       H'2A'               ;
TPORTB    EQU       H'2B'               ;
BYT4      EQU       H'2C'               ;
;         EQU       H'2D'               ;
;         EQU       H'2E'               ;
;         EQU       H'2F'               ;

;------ COSTANTI --------------------------------------------------------

IND5511   EQU       B'11000010'         ;indirizzo slave 5511

F1237_H   EQU       B'01001101'
F1237_L   EQU       B'01010000'

F1240_H   EQU       B'01001101'
F1240_L   EQU       B'10000000'

F1256_H   EQU       B'01001110'
F1256_L   EQU       B'10000000'

F1272_H   EQU       B'01001111'
F1272_L   EQU       B'10000000'

BYTE4     EQU       B'10001110'         ;byte 4 5511

BYTE5     EQU       B'00000000'         ;byte 5 5511

II2       EQU       PORTA
SCL       EQU       1
SDA       EQU       0

PAUSA     EQU       D'60'

;Tcy      32768/4 = 8192 Hz 0.122 ms

;FLAG,0   tasto premuto
;FLAG,1   errore dati ram
;FLAG,2   antirimbalzo

;------- RESET ---------------------------------------------------------
          
          org       0
;          call test
;yyy
          goto      start
          
;------- INTERUPT ------------------------------------------------------         
          
          org       4
          retfie

;------- START --------------------------------------------------------

start     call      init                ;init pic         
          call      f2
          call      delay2
          clrwdt
          call      send_pll
          movlw     PAUSA
          movwf     CONT1
          clrwdt

;--- MAIN ---------------------------------------------------

main
          call      tasti               ;lttura ingressi
          btfss     FLAG,0              ;1 se tasto premuto
          goto      aaa
          goto      bbb

aaa       bsf       FLAG,2
          goto      main1
          
bbb
          btfss     FLAG,2              ; 
          goto      main1         
          bcf       FLAG,2
          call      send_pll
main1
          call      delay3              ;tempo fra letture tasti
          call      clear               ;###########
          decfsz    CONT1,F
          goto      main
          movlw     PAUSA
          movwf     CONT1

          call      verifica            ;se errore ram resetta
          btfsc     FLAG,1
          goto      start
          call      send_pll            ;se ok riscrive il pll
          call      delay3

          goto      main
          goto      main


;----- scansione tasti -------------------------------------------

tasti
          bsf       FLAG,0
          movf      PORTB,W             ;interrogo la porta
          movwf     TPORTB
          andlw     B'00001111'         ;elimino i bit non validi
          addwf     PCL,F
          nop                           ;0
          nop                           ;1
          nop                           ;2
          nop                           ;3
          nop                           ;4
          nop                           ;5
          goto      nullo               ;6
          goto      f4                  ;7
          nop                           ;8
          nop                           ;9
          goto      nullo               ;10
          goto      f3                  ;11
          goto      nullo               ;12
          goto      f2                  ;13 
          goto      f1                  ;14 
nullo     bcf       FLAG,0              ;15  nullo        
          return

;------ setta frequenze ----------------------------------------------------

f1        movlw     F1237_H
          movwf     DIV_H
          movlw     F1237_L
          movwf     DIV_L          
          return

f2        movlw     F1240_H
          movwf     DIV_H
          movlw     F1240_L
          movwf     DIV_L          
          return

f3        movlw     F1256_H
          movwf     DIV_H
          movlw     F1256_L
          movwf     DIV_L          
          return

f4        movlw     F1272_H
          movwf     DIV_H
          movlw     F1272_L
          movwf     DIV_L          
          return

;--- send pll ---------------------------------

send_pll

out_iic   call      start_iic

          movlw     IND5511             ;indirizzo pll
          call      tx_iic
          movf      DIV_H,W             ;divisore msb
          call      tx_iic
          movf      DIV_L,W             ;divisore lsb
          call      tx_iic
          movlw     BYTE4               ;byte 4
          call      portx

          call      tx_iic
          movlw     BYTE5               ;byte 5
          call      tx_iic       
          call      stop_iic
          return

;----- porte 4-7 --------------------------------------
portx          
          movwf     BYT4
          btfss     TPORTB,6
          bsf       BYT4,5
          btfss     TPORTB,7
          bsf       BYT4,6
          movf      BYT4,W
          return

;--- TX IIC -------------------------------------------

tx_iic    movwf     TX_BUF 
          movlw     D'8'
          movwf     CONT

lpiic     rlf       TX_BUF,F
          btfsc     STATUS,C
          bsf       II2,SDA
          btfss     STATUS,C
          bcf       II2,SDA
          call      rit_iic
;clock          
          bsf       II2,SCL
          call      rit_iic
          bcf       II2,SCL
          decfsz    CONT,F
          goto      lpiic
;ack       
          call      rit_iic             ;prepara alta la linea dati
          bsf       II2,SDA
          call      rit_iic
          bsf       STATUS,RP0
          nop
          bsf       TRISA,SDA           ;linea dati come ingresso
          bcf       STATUS,RP0
          call      rit_iic
          bsf       II2,SCL             ;ciclo di clock ack
          call      rit_iic
          btfsc     II2,SDA             ;test ack
          nop

        ;  goto      err_iic

          bcf       II2,SCL
          call      rit_iic
          bsf       STATUS,RP0
          nop
          bcf       TRISA,SDA           ;linea dati come uscita
          bcf       STATUS,RP0
          return


;---- START STOP II2 ----------------------------

start_iic bsf       II2,SCL
          call      rit_iic
          bcf       II2,SDA
          call      rit_iic
          bcf       II2,SCL
          return

stop_iic  bcf       II2,SDA
          call      rit_iic
          bsf       II2,SCL
          call      rit_iic
          bsf       II2,SDA
          return

;--- ritardo ------------------------------------

rit_iic   nop
         ; nop
          return

;--- loop errore, fa intervenire il wdt -----------------------

err_iic                       
          clrwdt
          bsf       STATUS,RP0
          movlw     B'00011001'         
          movwf     OPTION_REG          ;Setta il registro OPTION
          bcf       STATUS,RP0
errii2    goto      errii2
          return
          
;----- DELAY --------------------------------------------------

delay2    movlw     D'4'
          goto      delay
delay3    movlw     D'2'

delay     movwf     TDEL            
          clrf      RRIT            
loop2     decfsz    RRIT,F ;LSD   
          goto      loop2
          decfsz    TDEL,F ;MSD
          goto      loop2
          return

;-------- verifica ---------------------------------------
verifica

dih1      movlw     F1237_H
          xorwf     DIV_H,W
          btfsc     STATUS,Z     
          goto      dil1

dih2      movlw     F1240_H
          xorwf     DIV_H,W
          btfsc     STATUS,Z     
          goto      dil2

dih3      movlw     F1256_H
          xorwf     DIV_H,W
          btfsc     STATUS,Z               
          goto      dil3

dih4      movlw     F1272_H
          xorwf     DIV_H,W
          btfsc     STATUS,Z                     
          goto      dil4

diverr    bsf       FLAG,1
          return

divok     bcf       FLAG,1
          return

dil1      movlw     F1237_L
          xorwf     DIV_L,W
          btfsc     STATUS,Z     
          goto      divok
          goto      diverr

dil2      movlw     F1240_L
          xorwf     DIV_L,W
          btfsc     STATUS,Z     
          goto      divok
          goto      diverr

dil3      movlw     F1256_L
          xorwf     DIV_L,W
          btfsc     STATUS,Z     
          goto      divok
          goto      diverr

dil4      movlw     F1272_L
          xorwf     DIV_L,W
          btfsc     STATUS,Z     
          goto      divok
          goto      diverr

          return

;----- INIZ PIC ---------------------------------------

init      bsf       STATUS,RP0
          movlw     B'00011111'         
          movwf     OPTION_REG          ;Setta il registro OPTION
          bcf       STATUS,RP0
          clrwdt                        ;Zero wdt e prescaler   
          clrf      INTCON
          clrf      PORTA
          clrf      PORTB
          bsf       STATUS,RP0
          movlw     B'00010000'         ; 1= ingresso  0= uscita
          movwf     TRISA               ; I/O PORTA, 4,3,2,1,0 bit
          movlw     B'11111111'         ; 1= ingresso  0= uscita
          movwf     TRISB               ; I/O PORTB, 8 bit
          bcf       STATUS,RP0
          movlw     B'00000011'
          movwf     PORTA
          clrf      PORTB          
          clrf      FLAG
          return
          goto      start

clear     clrwdt
          return
          goto      start

;-------------------------------------------------------------
          
          DT        "V0.1" 
          DT        "24/03/2001"
          DT        "I3OIB" 
          DT        "DAL BIANCO PIETRO" 
          
        END

;----- FINE --------------------------------------------------------
